<?php 

if (!defined("PHORUM")) return;

require_once("./mods/solr_search/defaults.php");

function solr_search_action($arrSearch)
{
	global $PHORUM;
	
	$post = array();
	$post[] = "q=".$arrSearch['search'];
	if($arrSearch['match_forum'] != "ALL")
	{
		$forums = explode(",", $arrSearch['match_forum']);
		$forumcount = count($forums);
		$forumlist = array();
		for($x=0;$x<$forumcount;$x++)
		{
			$forumlist[] = "forum_id:".$forums[$x];
		}
		
		$query = implode("%20OR%20", $forumlist);

		$post[] = "fq=".$query;
	}
	
	
	$params = implode("&", $post); 

	$path = "http://".$PHORUM["mod_solr_search"]["hostname"].":".$PHORUM["mod_solr_search"]["port"]."/solr/select/?wt=json&hl.fl=message&hl=true&hl.simple.pre=<b>&hl.simple.post=</b>&".$params;
	$retval = file_get_contents($path);

	$results = json_decode($retval, true);
	
	if (! isset($results["response"]['docs']) || count($results["response"]['docs']) == 0) {
        $arrSearch['results']=array();
        $arrSearch['totals']=0;
        $arrSearch['continue']=0;
        $arrSearch['raw_body']=1;
        return $arrSearch;
    }

    $arrMessageID = array();
    $countResults = count($results["response"]['docs']);
    $arrResults = $results["response"]['docs'];

    for($x=0;$x<$countResults;$x++)
    {
    	$arrMessageID[] = $arrResults[$x]['message_id'];
    }

    $found_messages = phorum_db_get_message($arrMessageID,'message_id',true);
    
    krsort($found_messages);
    reset($found_messages);
    
    $docs=array();
    foreach($found_messages as $id => $data) {

        $data['body']=preg_replace("/(\[hide=([\#a-z0-9]+?)\](.+?)\[\/hide\])/is", "", $data['body']);

        $docs[] = htmlspecialchars(phorum_strip_body($data['body']));
    }
    
    $words=implode(" ",array_keys($results['words']));

    $opts=array('chunk_separator'=>' [...] ');

    $cnt=0;
    foreach($found_messages as $id => $content) {
        $found_messages[$id]['short_body'] = $results['highlighting'][$id]['message'][0];//$highlighted[$cnt];
        $cnt++;
    }

    $arrSearch['results']=$found_messages;
    $arrSearch['totals']=$results['total_found'];
    
    if($arrSearch['totals'] > 1000) {
    	$arrSearch['totals'] = 1000;
    }
    
    // don't run the default search
    $arrSearch['continue']=0;
    // tell it to leave the body alone
    $arrSearch['raw_body']=1;
    
	return $arrSearch;
}

function solr_after_message_save($arrMessage)
{
	global $PHORUM;
	
	$strData = "<add><doc>";
	
	$strData .= "<field name=\"forum_id\">".$arrMessage['forum_id']."</field>";
	$strData .= "<field name=\"thread_id\">".$arrMessage['thread']."</field>";
	$strData .= "<field name=\"message_id\">".$arrMessage['message_id']."</field>";
	$strData .= "<field name=\"author\">".$arrMessage['author']."</field>";
	$strData .= "<field name=\"subject\">".$arrMessage['subject']."</field>";
	$strData .= "<field name=\"message\">".$arrMessage['body']."</field>";
	$strData .= "<field name=\"datestamp\">".date('c', $arrMessage['datestamp'])."Z</field>";
	$strData .= "</doc></add>";

	do_post_request("http://".$PHORUM["mod_solr_search"]["hostname"].":".$PHORUM["mod_solr_search"]["port"]."/solr/update", $strData, 'Content-Type: text/xml');
	
	do_flush();
	
	return $arrMessage;
	
}

function solr_message_delete($arrMessageIDs)
{
	global $PHORUM;
	
	$arrDelete = array();
	
	foreach($arrMessageIDs as $id)
	{
		$arrDelete[] = "<id>".$id."</id>";
	}
	
	$strData = "<delete>".implode("", $arrDelete)."</delete>";
	
	do_post_request("http://".$PHORUM["mod_solr_search"]["hostname"].":".$PHORUM["mod_solr_search"]["port"]."/solr/update", $strData, 'Content-Type: text/xml');
	
	do_flush();
	
	return $arrMessageIDs;
}

function do_flush()
{
	global $PHORUM;
	
	do_post_request("http://".$PHORUM["mod_solr_search"]["hostname"].":".$PHORUM["mod_solr_search"]["port"]."/solr/update", '<commit waitFlush="false" waitSearcher="false"/>', 'Content-Type: text/xml');
}


function do_post_request($url, $data, $optional_headers = null)
{
   $params = array('http' => array(
                'method' => 'POST',
                'content' => $data
             ));
   if ($optional_headers !== null) {
      $params['http']['header'] = $optional_headers;
   }
   $ctx = stream_context_create($params);
   $fp = @fopen($url, 'rb', false, $ctx);
   if (!$fp) {
      throw new Exception("Problem with $url, $php_errormsg");
   }
   $response = @stream_get_contents($fp);
   if ($response === false) {
      throw new Exception("Problem reading data from $url, $php_errormsg");
   }
   return $response;
}

if(!function_exists("json_decode"))
{
	require_once("./mods/solr_search/json.php");
	
	function json_decode($object)
	{
		$json = new Services_JSON(SERVICES_JSON_LOOSE_TYPE);
	
		return $json->decode( $object ); 
	}
}

?>